<?php declare(strict_types=1);

namespace Infomaker\Everyware\Base;

/**
 * Interface ContentProvider
 *
 * @link    http://infomaker.se
 * @package Infomaker\Everyware\Base
 * @since   Infomaker\Everyware\Base\ContentProvider 1.0.0
 */
interface ContentProvider
{

    /**
     * @param array $params
     *
     * @return array
     */
    public function queryWithRequirements(array $params = []): array;

    /**
     * @param string $reference
     *
     */
    public function setPropertyMap(string $reference): void;

    /**
     * The number of matches from the last query
     *
     * @return int
     */
    public function hits(): int;
}
